function [ nb ] = Clones_CardPsi( D )
%Clones_CardPsi Find the cardinality of Psi(D)
%	Clones_CardPsi(D) 
%           D : diagram representation
%
%	[nb] = Clones_CardPsi(D) 
%           nb : if it is possible then return the cardinality of Psi(D) else
%           return -1
%
%	See also :
%               Clones_D
%               Clones_Psi

% C. Rovetta
% 11.09.2014
% Version 1.0
%


[MM kk]=size(D);

K=kk/MM;
M=MM-1;

% Last Matrix
mm=(K-1)*MM+1;
Mat=D(:,mm:mm+M);

vm=sum(Mat,2)';
Matv=repmat(vm,MM,1);


for k=K-1:-1:2
    
    mm=mm-MM;
    Mat=D(:,mm:mm+M);
   
    Mat=Mat.*Matv;
   
    vm=sum(Mat,2)';
    Matv=repmat(vm,MM,1);
    
    % Control if card is not too large
    if(vm(1)>(realmax/K))
        nb=-1;
        return
    end
    
end

% First matrix
Mat=D(:,1:MM);
Mat=Mat.*Matv;
vm=sum(Mat,2);

nb=vm(1);

end

