classdef Clones_D
%Clones_D Class of diagrams
%           K : queues number
%           M : customers number
%           C : vector of capacities
%           D : matrix representation of diagram
%           cD : matrix representation of complete diagram

% C. Rovetta
% 11.04.2015
% Version 2.0
%

    
    properties
        Mod % Model to consider
        K
        M
        C
        D
        cD %Complete Diagram
    end
    
    methods
        function obj = Clones_D(mod)
            obj.Mod=mod;
            obj.K=mod.K;
            obj.M=mod.M;
            obj.C=mod.C;
            obj.cD=Clones_CompleteD(mod.C,mod.M);
            obj.D=obj.cD;
        end
        
        function obj=reset(obj)
            obj.D= obj.cD;
        end
        
        function obj=T(obj,r)
            obj.D=Clones_T(obj.D,obj.C,r);
        end
        
        function obj=Tm(obj,r)
            obj.D=Clones_Tm(obj.D,obj.C,r);
        end
        
        function S=Psi(obj)
            S=Clones_Psi(obj.D);
        end
        
        function card=cardPsi(obj)
            card=Clones_CardPsi(obj.D);
        end
        
        function res=onePath(obj)
            res=Clones_OnePath(obj.D);
        end
        
        function mov = plot(obj,mode)
            mov = Clones_plotD(obj.D,obj.C,mode);
        end
        
    end
    
    
end
