function [S] = Clones_Psi(D)
%Clones_Psi Find S=Psi(D)
%	Clones_Psi(D) 
%           D : diagram representation
%
%	[S] = Clones_Psi(D) 
%           S : return Psi(D)
%
%	See also :
%               Clones_D
%               Clones_CardPsi

% C. Rovetta
% 11.09.2014
% Version 1.0
%


[MM kk]=size(D);

M=MM-1;
K=kk/MM;

v=-ones(1,MM);
v=cumsum(v);
v=v';

% First matrix
mm=1;
Mat=D(:,mm:mm+M);

% == Evalue slope
vp=(Mat(1,:))';
vp=(vp.*v);

S=-vp-1;
S(vp==0)=[];


 for k=2:K
     
     NS=[];
     
     mm=mm+MM;
     Mat=D(:,mm:mm+M); 
     
     vk=sum(S,2);
     
     vku=unique(vk,'rows');
    
     
     for ll=1:size(vku,1)
         
         % Line in the diagram
         l=vku(ll);
             
         % Values of slope
         vpl=(Mat(l+1,:))';
         vpl=(vpl.*v);
         
         Sl=-vpl-l-1;
         Sl(vpl==0)=[];
         
         sSl=size(Sl,1);
         
         % Add to the previous matrix
         OSl=S;
         OSl(vk~=l,:)=[];
         sOSl=size(OSl,1);
         
         OSl=repmat(OSl,sSl,1);
        
         Sl=Sl';
         Sl=repmat(Sl,sOSl,1);
         Sl=Sl(:);
         
         NS=[NS;[OSl Sl]];
         
     end
     
      S=NS;
       
 end
 
% Integrity control
vend=M-sum(S,2);

if(sum(vend)>0)
    display(vend);
    display('Psi has a problem ...');
end

%S=unique(S,'rows');

end



