function [ F ] = Clones_FindPath2(N,F,X )
%Clones_FindPath2 Compute Fi->j i>j
%	Clones_FindPath2(N,F,X)
%       N: Matrix to find Fij
%       F: Matrix representation
%       X: Submatrix representation of V
%         
%
% C. Rovetta
% 11.09.2014
% Version 1.0
%



% Test if the matrix does not contain arcs
v=(X(:,1)>-1);
testY=sum(sum(v,1));
if(testY==0)
    [l c]=size(F);
    F=ones(l,c)*-1;
    return
end

K=size(N,1);
F(N(end-1)+1:end,:)=X;

for k=K-2:-1:1
    
    % Find min-max for the next matrix
    vnc=(X(:,1)==-1);
    
    X(vnc,:)=[];
    debut=min(X(:,1));
    fin=max(X(:,2));
    
    
    % Update matrix
    X=F(N(k)+1:N(k+1),:);
    vnc=(X(:,1)==-1);
    
    vMk=(0:size(X,1)-1)';
    vMk=repmat(vMk,1,2);
    
    X=X+vMk;
    
    X(:,1)=max(X(:,1),debut);
    X(:,2)=min(X(:,2),fin);
    
    X=X-vMk;
    X(vnc,:)=-1;
    
    vnc=(X(:,1)>X(:,2));
    X(vnc,:)=-1;
    
    F(N(k)+1:N(k+1),:)=X;

end



end

