function [ D ] = Clones_FtoD(F,C,M)
%Clones_FtoD Transform a gap-free diagram in a diagram
%	Clones_FtoD(F,C,M)
%           F : gap-free representation
%           C : vector of capacities
%           M : custumers number
%
%	[D] = Clones_FtoD(C,M) 
%           D :  diagram
%
%	See also :
%               Clones_CompleteF
%
% C. Rovetta
% 25.09.2014
% Version 1.0
%

K=size(C,2);
D=zeros(M+1,(M+1)*K);

mm=1;
cc=1;
for k=1:K
   
    X=F(cc:cc+C(k),:);
    DD=D(:,mm:mm+M);
    
    XT=X(:,2)-X(:,1);
    XT=XT+1;
  
    for d=1:C(k)+1
        if(X(d,1)~=-1) 
            
            taille=M+2-d;
            
            if(X(d,1)==0)
               vD=[ones(XT(d,1),1) ; zeros(taille-XT(d,1),1)]; 
            else
               vD=[zeros(X(d,1),1) ; ones(XT(d,1),1) ; zeros(taille-XT(d,1)-X(d,1),1)];
            end
            
            DD=DD+diag(vD,d-1);
        end
    end
    
    D(:,mm:mm+M)=DD;
    
    cc=cc+C(k)+1;
    mm=mm+M+1;
    
   
end

end

