function [X] = Clones_PSD(Diagram,nb)
%Clones_PSD Produce nb randoms states with PSD
%	Clones_PSD(Model,nb) 
%           Model : Model with parameters
%           nb : nb of random sampler to produce
%
%   [ X ] = matrix of random sampler of size nb x K

% C. Rovetta
% 11.04.2015
% Version 2.0
%

Model=Diagram.Mod;
K=Model.K;
PP=Model.PP;
Nuu=Model.Nuu;
E=Model.E;


% Matrix of samplers
X=zeros(nb,K);

for a=1:nb
    
    Diagram=reset(Diagram);
    
    n=1;
    Un=Clones_rand_ijm(PP,Nuu,E);
    Diagram=Tm(Diagram,Un);
    
    while ~onePath(Diagram)
        
        nn=2*n;
        Unn=zeros(nn,3);
        for k=1:n
            Unn(k,:)=Clones_rand_ijm(PP,Nuu,E);
        end
        Unn(n+1:end,:)=Un;
        Un=Unn;
        n=nn;
        
        Diagram=reset(Diagram);
        for k=1:n
            Diagram=Tm(Diagram,Un(k,:));
        end
        
    end
    
    X(a,:)=Psi(Diagram); 
    
end



end

