function [X] = Clones_PSF(GapFree,nb)
%Clones_PSD Produce nb randoms states with PSF
%	Clones_PSF(Model,nb) 
%           Model : Model with parameters
%           nb : nb of random sampler to produce
%
%   [ X ] = matrix of random sampler of size nb x K

% C. Rovetta
% 11.04.2015
% Version 2.0
%

Model=GapFree.Mod;
K=Model.K;

PP=Model.PP;
Nuu=Model.Nuu;
E=Model.E;


% Matrix of results
X=zeros(nb,K);


for a=1:nb
    
    GapFree=reset(GapFree);
    
    n=1;
    Un=Clones_rand_ijm(PP,Nuu,E);
    GapFree=gfTm(GapFree,Un);
    
    while cardPsi(GapFree)>1
        
        nn=2*n;
        Unn=zeros(nn,3);
        for k=1:n
            Unn(k,:)=Clones_rand_ijm(PP,Nuu,E);
        end
        Unn(n+1:end,:)=Un;
        Un=Unn;
        n=nn;
        
        GapFree=reset(GapFree);
        for k=1:n
            GapFree=gfTm(GapFree,Un(k,:));
        end
        
    end
    
    X(a,:)=Psi(GapFree); 
    
end



end

