function [X] = Clones_PSS(States,nb)
%Clones_PSS Produce nb randoms states with PSS
%	Clones_PSS(K,M,C) 
%           Model : Model with parameters
%           nb : nb of random sampler to produce
%
%   [ X ] = r.v. sample dist
%         

% C. Rovetta
% 03.04.2015
% Version 2
%

% Parameters
Model=States.Mod;
K=Model.K;
PP=Model.PP;
Nuu=Model.Nuu;
E=Model.E;

% Matrix of samplers
X=zeros(nb,K);

for a=1:nb
    
    States=reset(States);
    
    n=1;
    Un=Clones_rand_ijm(PP,Nuu,E);
    States=tm(States,Un);
    
    while card(States)>1
        
        nn=2*n;
        Unn=zeros(nn,3);
        for k=1:n
            Unn(k,:)=Clones_rand_ijm(PP,Nuu,E);
        end
        Unn(n+1:end,:)=Un;
        Un=Unn;
        n=nn;
        
        States=reset(States);
        for k=1:n
            States=tm(States,Un(k,:));
        end
        
    end
    
    X(a,:)=States.S; 
    
end



end

