function [ r ] = Clones_rand_ij(PP,Nuu)
%Clones_rand_ij Produce a random couple [i j] according to PP and Nuu
%	Clones_rand_ij(PP,Nuu)
%           PP :  cumsum of the routing matrix P
%           Nuu : cumsum of the normalized matrix of service rate Nu
%   [ r ] = Clones_rand_ij(PP,Nuu)
%           r : couple i, j

% C. Rovetta
% 11.09.2014
% Version 1.0
%

K=size(Nuu,2);
vK=1:K;

% i choice 
alea=rand;
I=Nuu>alea;
I=I.*vK;
I(I==0)=[];
i=min(I);

% j choice 
alea=rand;
I=PP(i,:)>alea;
I=I.*vK;
I(I==0)=[];
j=min(I);

r=[i,j];

end

