function [ S ] = Clones_t(S,C,r)
%Clones_t Transition i->j on the set of states
%	Clones_t(S,C,r)
%           S : state space
%           C : vector of capacities
%           r : r=[i j] transition
%
%	[S] = Clones_t(K,M) 
%           S : transition of the state space
%
%	See also :
%               Clones_CompleteS

% C. Rovetta
% 11.09.2014
% Version 1.0
%

i=r(1);
j=r(2); 

 % Subset
 NE=S(:,i)>0;
 NF=S(:,j)<C(j);
 Tr=(NE&NF);
 
 % Transition i->j
 S(:,i)=S(:,i)-Tr;
 S(:,j)=S(:,j)+Tr;
 
 S=unique(S,'rows');

end


